// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _MigrationLatLng_lat, _MigrationLatLng_lng, _MigrationLatLngBounds_lngLatBounds;
import { LngLatBounds } from "maplibre-gl";
// Migration version of google.maps.LatLng
export class MigrationLatLng {
    constructor(latOrLatLngOrLatLngLiteral, lngOrNoClampNoWrap, noClampNoWrap) {
        _MigrationLatLng_lat.set(this, void 0);
        _MigrationLatLng_lng.set(this, void 0);
        if (latOrLatLngOrLatLngLiteral == null) {
            __classPrivateFieldSet(this, _MigrationLatLng_lat, NaN, "f");
            __classPrivateFieldSet(this, _MigrationLatLng_lng, NaN, "f");
        }
        else if (typeof latOrLatLngOrLatLngLiteral === "number") {
            __classPrivateFieldSet(this, _MigrationLatLng_lat, latOrLatLngOrLatLngLiteral, "f");
        }
        else if (latOrLatLngOrLatLngLiteral.lat !== undefined && latOrLatLngOrLatLngLiteral.lng !== undefined) {
            if (typeof latOrLatLngOrLatLngLiteral.lat === "number" && typeof latOrLatLngOrLatLngLiteral.lng === "number") {
                __classPrivateFieldSet(this, _MigrationLatLng_lat, latOrLatLngOrLatLngLiteral.lat, "f");
                __classPrivateFieldSet(this, _MigrationLatLng_lng, latOrLatLngOrLatLngLiteral.lng, "f");
            }
            else if (typeof latOrLatLngOrLatLngLiteral.lat === "function" &&
                typeof latOrLatLngOrLatLngLiteral.lng === "function") {
                __classPrivateFieldSet(this, _MigrationLatLng_lat, latOrLatLngOrLatLngLiteral.lat(), "f");
                __classPrivateFieldSet(this, _MigrationLatLng_lng, latOrLatLngOrLatLngLiteral.lng(), "f");
            }
        }
        let shouldClamp = true;
        if (typeof lngOrNoClampNoWrap === "number") {
            __classPrivateFieldSet(this, _MigrationLatLng_lng, lngOrNoClampNoWrap, "f");
        }
        else if (typeof lngOrNoClampNoWrap === "boolean") {
            shouldClamp = !lngOrNoClampNoWrap;
        }
        if (typeof noClampNoWrap === "boolean") {
            shouldClamp = !noClampNoWrap;
        }
        if (shouldClamp && __classPrivateFieldGet(this, _MigrationLatLng_lat, "f") != null && __classPrivateFieldGet(this, _MigrationLatLng_lng, "f") != null) {
            // Latitude should be clamped to [-90, 90]
            if (__classPrivateFieldGet(this, _MigrationLatLng_lat, "f") < -90) {
                __classPrivateFieldSet(this, _MigrationLatLng_lat, -90, "f");
            }
            else if (__classPrivateFieldGet(this, _MigrationLatLng_lat, "f") > 90) {
                __classPrivateFieldSet(this, _MigrationLatLng_lat, 90, "f");
            }
            // Longitude should be wrapped to [-180, 180]
            const minLongitude = -180;
            const maxLongitude = 180;
            if (__classPrivateFieldGet(this, _MigrationLatLng_lng, "f") < minLongitude || __classPrivateFieldGet(this, _MigrationLatLng_lng, "f") > maxLongitude) {
                const range = maxLongitude - minLongitude;
                const wrapped = ((((__classPrivateFieldGet(this, _MigrationLatLng_lng, "f") - minLongitude) % range) + range) % range) + minLongitude;
                __classPrivateFieldSet(this, _MigrationLatLng_lng, wrapped, "f");
            }
        }
    }
    equals(other) {
        return other ? this.lat() == other.lat() && this.lng() == other.lng() : false;
    }
    lat() {
        return __classPrivateFieldGet(this, _MigrationLatLng_lat, "f");
    }
    lng() {
        return __classPrivateFieldGet(this, _MigrationLatLng_lng, "f");
    }
    toString() {
        return "(" + this.lat() + ", " + this.lng() + ")";
    }
    toJSON() {
        return {
            lat: this.lat(),
            lng: this.lng(),
        };
    }
    // Rounded to 6 decimal places by default
    toUrlValue(precision = 6) {
        // Trim trailing 0's by using trick of dividing by 1 afterwards
        const latDigits = this.lat().toPrecision(precision);
        const latTrimmed = parseFloat(latDigits) / 1;
        const lngDigits = this.lng().toPrecision(precision);
        const lngTrimmed = parseFloat(lngDigits) / 1;
        return `${latTrimmed},${lngTrimmed}`;
    }
}
_MigrationLatLng_lat = new WeakMap(), _MigrationLatLng_lng = new WeakMap();
// Migration version of google.maps.LatLngBounds
export class MigrationLatLngBounds {
    constructor(swOrLatLngBounds, ne) {
        _MigrationLatLngBounds_lngLatBounds.set(this, void 0);
        let west, south, east, north;
        if (!swOrLatLngBounds) {
            // Inputs are empty, so create an empty LngLatBounds
            __classPrivateFieldSet(this, _MigrationLatLngBounds_lngLatBounds, new LngLatBounds(), "f");
            return;
        }
        else {
            let southWest, northEast;
            if (ne) {
                southWest = new MigrationLatLng(swOrLatLngBounds);
                northEast = new MigrationLatLng(ne);
                west = southWest.lng();
                south = southWest.lat();
                east = northEast.lng();
                north = northEast.lat();
            }
            else if (swOrLatLngBounds instanceof MigrationLatLngBounds) {
                southWest = swOrLatLngBounds.getSouthWest();
                northEast = swOrLatLngBounds.getNorthEast();
                west = southWest.lng();
                south = southWest.lat();
                east = northEast.lng();
                north = northEast.lat();
            } /* LatLngBoundsLiteral */
            else {
                const boundsLiteral = swOrLatLngBounds;
                west = boundsLiteral.west;
                south = boundsLiteral.south;
                east = boundsLiteral.east;
                north = boundsLiteral.north;
            }
            // west, south, east, north
            __classPrivateFieldSet(this, _MigrationLatLngBounds_lngLatBounds, new LngLatBounds([west, south, east, north]), "f");
        }
    }
    contains(latLng) {
        return __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").contains(LatLngToLngLat(latLng));
    }
    equals(other) {
        const otherBounds = new MigrationLatLngBounds(other);
        return (this.getSouthWest().equals(otherBounds.getSouthWest()) && this.getNorthEast().equals(otherBounds.getNorthEast()));
    }
    extend(point) {
        const lngLat = LatLngToLngLat(point);
        __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").extend(lngLat);
        return this;
    }
    getCenter() {
        const lngLatCenter = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getCenter();
        return new MigrationLatLng(lngLatCenter.lat, lngLatCenter.lng);
    }
    getNorthEast() {
        const northEast = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getNorthEast();
        return new MigrationLatLng(northEast.lat, northEast.lng);
    }
    getSouthWest() {
        const southWest = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getSouthWest();
        return new MigrationLatLng(southWest.lat, southWest.lng);
    }
    isEmpty() {
        return __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").isEmpty();
    }
    toJSON() {
        return {
            east: __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getEast(),
            north: __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getNorth(),
            west: __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getWest(),
            south: __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getSouth(),
        };
    }
    toSpan() {
        const latSpan = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getNorth() - __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getSouth();
        const lngSpan = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getEast() - __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getWest();
        return new MigrationLatLng(latSpan, lngSpan);
    }
    toString() {
        const south = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getSouth();
        const west = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getWest();
        const north = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getNorth();
        const east = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getEast();
        return `((${south}, ${west}), (${north}, ${east}))`;
    }
    // Rounded to 6 decimal places by default
    toUrlValue(precision = 6) {
        // Trim trailing 0's by using trick of dividing by 1 afterwards
        const southDigits = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getSouth().toPrecision(precision);
        const southTrimmed = parseFloat(southDigits) / 1;
        const westDigits = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getWest().toPrecision(precision);
        const westTrimmed = parseFloat(westDigits) / 1;
        const northDigits = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getNorth().toPrecision(precision);
        const northTrimmed = parseFloat(northDigits) / 1;
        const eastDigits = __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").getEast().toPrecision(precision);
        const eastTrimmed = parseFloat(eastDigits) / 1;
        return `${southTrimmed},${westTrimmed},${northTrimmed},${eastTrimmed}`;
    }
    union(other) {
        const bounds = new MigrationLatLngBounds(other);
        __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f").extend(bounds._getBounds());
        return this;
    }
    // Internal method for migration logic that needs to access the underlying MapLibre LngLatBounds
    _getBounds() {
        return __classPrivateFieldGet(this, _MigrationLatLngBounds_lngLatBounds, "f");
    }
}
_MigrationLatLngBounds_lngLatBounds = new WeakMap();
// function that takes in a Google LatLng or LatLngLiteral and returns array containing a
// longitude and latitude (valid MapLibre input), returns 'null' if 'coord' parameter
// is not a Google LatLng or LatLngLiteral
export const LatLngToLngLat = function (coord) {
    const latLng = new MigrationLatLng(coord);
    const lat = latLng.lat();
    const lng = latLng.lng();
    if (isFinite(lat) && isFinite(lng)) {
        return [lng, lat];
    }
    return null;
};
export const PlacesServiceStatus = {
    OK: "OK",
    UNKNOWN_ERROR: "UNKNOWN_ERROR",
    OVER_QUERY_LIMIT: "OVER_QUERY_LIMIT",
    REQUEST_DENIED: "REQUEST_DENIED",
    INVALID_REQUEST: "INVALID_REQUEST",
    ZERO_RESULTS: "ZERO_RESULTS",
    NOT_FOUND: "NOT_FOUND",
};
export var DirectionsStatus;
(function (DirectionsStatus) {
    DirectionsStatus["OK"] = "OK";
    DirectionsStatus["UNKNOWN_ERROR"] = "UNKNOWN_ERROR";
    DirectionsStatus["OVER_QUERY_LIMIT"] = "OVER_QUERY_LIMIT";
    DirectionsStatus["REQUEST_DENIED"] = "REQUEST_DENIED";
    DirectionsStatus["INVALID_REQUEST"] = "INVALID_REQUEST";
    DirectionsStatus["ZERO_RESULTS"] = "ZERO_RESULTS";
    DirectionsStatus["MAX_WAYPOINTS_EXCEEDED"] = "MAX_WAYPOINTS_EXCEEDED";
    DirectionsStatus["NOT_FOUND"] = "NOT_FOUND";
})(DirectionsStatus || (DirectionsStatus = {}));
export var GeocoderStatus;
(function (GeocoderStatus) {
    GeocoderStatus["ERROR"] = "ERROR";
    GeocoderStatus["INVALID_REQUEST"] = "INVALID_REQUEST";
    GeocoderStatus["OK"] = "OK";
    GeocoderStatus["OVER_QUERY_LIMIT"] = "OVER_QUERY_LIMIT";
    GeocoderStatus["REQUEST_DENIED"] = "REQUEST_DENIED";
    GeocoderStatus["UNKNOWN_ERROR"] = "UNKNOWN_ERROR";
    GeocoderStatus["ZERO_RESULTS"] = "ZERO_RESULTS";
})(GeocoderStatus || (GeocoderStatus = {}));
// Migration version of google.maps.ControlPosition
export const MigrationControlPosition = {
    TOP_LEFT: 1,
    TOP_CENTER: 2,
    TOP: 2,
    TOP_RIGHT: 3,
    LEFT_CENTER: 4,
    LEFT_TOP: 5,
    LEFT: 5,
    LEFT_BOTTOM: 6,
    RIGHT_TOP: 7,
    RIGHT: 7,
    RIGHT_CENTER: 8,
    RIGHT_BOTTOM: 9,
    BOTTOM_LEFT: 10,
    BOTTOM_CENTER: 11,
    BOTTOM: 11,
    BOTTOM_RIGHT: 12,
    CENTER: 13,
    BLOCK_START_INLINE_START: 14,
    BLOCK_START_INLINE_CENTER: 15,
    BLOCK_START_INLINE_END: 16,
    INLINE_START_BLOCK_CENTER: 17,
    INLINE_START_BLOCK_START: 18,
    INLINE_START_BLOCK_END: 19,
    INLINE_END_BLOCK_START: 20,
    INLINE_END_BLOCK_CENTER: 21,
    INLINE_END_BLOCK_END: 22,
    BLOCK_END_INLINE_START: 23,
    BLOCK_END_INLINE_CENTER: 24,
    BLOCK_END_INLINE_END: 25,
};
// Constant responsible for translating numbers representing Google ControlPositions into MapLibre position
// strings that can be passed into MapLibre's 'addControl'
// see more on Google ControlPosition: https://developers.google.com/maps/documentation/javascript/controls#ControlPositioning
// see more on MapLibre ControlPosition: https://maplibre.org/maplibre-gl-js/docs/API/types/ControlPosition/
export const GoogleToMaplibreControlPosition = {};
GoogleToMaplibreControlPosition[MigrationControlPosition.TOP_LEFT] = "top-left";
GoogleToMaplibreControlPosition[MigrationControlPosition.TOP_RIGHT] = "top-right";
GoogleToMaplibreControlPosition[MigrationControlPosition.LEFT_TOP] = "top-left";
GoogleToMaplibreControlPosition[MigrationControlPosition.LEFT_BOTTOM] = "bottom-left";
GoogleToMaplibreControlPosition[MigrationControlPosition.RIGHT_TOP] = "top-right";
GoogleToMaplibreControlPosition[MigrationControlPosition.RIGHT_BOTTOM] = "bottom-right";
GoogleToMaplibreControlPosition[MigrationControlPosition.BOTTOM_LEFT] = "bottom-left";
GoogleToMaplibreControlPosition[MigrationControlPosition.BOTTOM_RIGHT] = "bottom-right";
// Migration version of Google's Events
export const MigrationEvent = {
    click: "click",
    dblclick: "dblclick",
    contextmenu: "contextmenu",
    mousemove: "mousemove",
    mouseout: "mouseout",
    mouseover: "mouseover",
    tilesloaded: "tilesloaded",
    tilt_changed: "tilt_changed",
    zoom_changed: "zoom_changed",
    drag: "drag",
    dragend: "dragend",
    dragstart: "dragstart",
    close: "close",
    closeclick: "closeclick",
};
// Constant responsible for translating Google Event names to corresponding MapLibre Event names,
// these Event names are passed into MapLibre's 'on' method
export const GoogleToMaplibreEvent = {};
GoogleToMaplibreEvent[MigrationEvent.click] = "click";
GoogleToMaplibreEvent[MigrationEvent.dblclick] = "dblclick";
GoogleToMaplibreEvent[MigrationEvent.contextmenu] = "contextmenu";
GoogleToMaplibreEvent[MigrationEvent.mousemove] = "mousemove";
GoogleToMaplibreEvent[MigrationEvent.mouseout] = "mouseout";
GoogleToMaplibreEvent[MigrationEvent.mouseover] = "mouseover";
GoogleToMaplibreEvent[MigrationEvent.tilesloaded] = "load";
GoogleToMaplibreEvent[MigrationEvent.tilt_changed] = "pitch";
GoogleToMaplibreEvent[MigrationEvent.zoom_changed] = "zoom";
GoogleToMaplibreEvent[MigrationEvent.drag] = "drag";
GoogleToMaplibreEvent[MigrationEvent.dragend] = "dragend";
GoogleToMaplibreEvent[MigrationEvent.dragstart] = "dragstart";
GoogleToMaplibreEvent[MigrationEvent.close] = "close";
GoogleToMaplibreEvent[MigrationEvent.closeclick] = "click";
// List of Google Map Events that include the MapMouseEvent parameter
export const GoogleMapMouseEvent = [
    MigrationEvent.click,
    MigrationEvent.dblclick,
    MigrationEvent.contextmenu,
    MigrationEvent.mousemove,
    MigrationEvent.mouseout,
    MigrationEvent.mouseover,
];
// List of Google Map Events that do not have any parameters
export const GoogleMapEvent = [
    MigrationEvent.tilesloaded,
    MigrationEvent.tilt_changed,
    MigrationEvent.zoom_changed,
    MigrationEvent.drag,
    MigrationEvent.dragend,
    MigrationEvent.dragstart,
];
// List of Google Marker Events that are supported by MapLibre Markers that include the MapMouseEvent parameter
export const GoogleMarkerMouseEvent = [MigrationEvent.drag, MigrationEvent.dragstart, MigrationEvent.dragend];
// List of Google Marker Events that are not supported by MapLibre Markers that include the MapMouseEvent parameter
// (must add event listener using DOM element)
export const GoogleMarkerMouseDOMEvent = [MigrationEvent.click, MigrationEvent.dblclick, MigrationEvent.contextmenu];
// List of Google InfoWindow Events
export const GoogleInfoWindowEvent = [MigrationEvent.close, MigrationEvent.closeclick];
