import { LocationClient } from "@aws-sdk/client-location";
import { LatLngLike, LatLngBoundsLike, MigrationLatLng, MigrationLatLngBounds } from "./googleCommon";
import { MigrationPlacesService } from "./places";
interface GeocoderRequest {
    address?: string | null;
    bounds?: LatLngBoundsLike | null;
    language?: string | null;
    location?: LatLngLike | null;
    placeId?: string | null;
}
interface GeocoderResponse {
    results: GeocoderResult[];
}
interface GeocoderResult {
    formatted_address: string;
    geometry: GeocoderGeometry;
    place_id: string;
}
interface GeocoderGeometry {
    bounds?: MigrationLatLngBounds;
    location: MigrationLatLng;
}
declare class MigrationGeocoder {
    _client: LocationClient;
    _placeIndexName: string;
    _placesService: MigrationPlacesService;
    geocode(request: GeocoderRequest, callback?: any): Promise<GeocoderResponse>;
}
export { GeocoderRequest, MigrationGeocoder };
