import { LngLatBounds } from "maplibre-gl";
export interface LatLngLiteral {
    lat: number;
    lng: number;
}
export type LatLngLike = LatLngLiteral | MigrationLatLng;
export interface LatLngBoundsLiteral {
    east: number;
    north: number;
    south: number;
    west: number;
}
export type LatLngBoundsLike = LatLngBoundsLiteral | MigrationLatLngBounds;
export declare class MigrationLatLng {
    #private;
    constructor(latOrLatLngOrLatLngLiteral: number | LatLngLiteral | MigrationLatLng, lngOrNoClampNoWrap?: number | boolean | null, noClampNoWrap?: boolean);
    equals(other: any): boolean;
    lat(): number;
    lng(): number;
    toString(): string;
    toJSON(): {
        lat: number;
        lng: number;
    };
    toUrlValue(precision?: number): string;
}
export declare class MigrationLatLngBounds {
    #private;
    constructor(swOrLatLngBounds?: MigrationLatLng | null | LatLngLiteral | MigrationLatLngBounds | LatLngBoundsLiteral, ne?: MigrationLatLng | null | LatLngLiteral);
    contains(latLng: any): boolean;
    equals(other: any): boolean;
    extend(point: any): this;
    getCenter(): MigrationLatLng;
    getNorthEast(): MigrationLatLng;
    getSouthWest(): MigrationLatLng;
    isEmpty(): boolean;
    toJSON(): {
        east: number;
        north: number;
        west: number;
        south: number;
    };
    toSpan(): MigrationLatLng;
    toString(): string;
    toUrlValue(precision?: number): string;
    union(other: any): this;
    _getBounds(): LngLatBounds;
}
export declare const LatLngToLngLat: (coord: any) => [number, number];
export declare const PlacesServiceStatus: {
    OK: string;
    UNKNOWN_ERROR: string;
    OVER_QUERY_LIMIT: string;
    REQUEST_DENIED: string;
    INVALID_REQUEST: string;
    ZERO_RESULTS: string;
    NOT_FOUND: string;
};
export declare enum DirectionsStatus {
    OK = "OK",
    UNKNOWN_ERROR = "UNKNOWN_ERROR",
    OVER_QUERY_LIMIT = "OVER_QUERY_LIMIT",
    REQUEST_DENIED = "REQUEST_DENIED",
    INVALID_REQUEST = "INVALID_REQUEST",
    ZERO_RESULTS = "ZERO_RESULTS",
    MAX_WAYPOINTS_EXCEEDED = "MAX_WAYPOINTS_EXCEEDED",
    NOT_FOUND = "NOT_FOUND"
}
export declare enum GeocoderStatus {
    ERROR = "ERROR",
    INVALID_REQUEST = "INVALID_REQUEST",
    OK = "OK",
    OVER_QUERY_LIMIT = "OVER_QUERY_LIMIT",
    REQUEST_DENIED = "REQUEST_DENIED",
    UNKNOWN_ERROR = "UNKNOWN_ERROR",
    ZERO_RESULTS = "ZERO_RESULTS"
}
export declare const MigrationControlPosition: {
    TOP_LEFT: number;
    TOP_CENTER: number;
    TOP: number;
    TOP_RIGHT: number;
    LEFT_CENTER: number;
    LEFT_TOP: number;
    LEFT: number;
    LEFT_BOTTOM: number;
    RIGHT_TOP: number;
    RIGHT: number;
    RIGHT_CENTER: number;
    RIGHT_BOTTOM: number;
    BOTTOM_LEFT: number;
    BOTTOM_CENTER: number;
    BOTTOM: number;
    BOTTOM_RIGHT: number;
    CENTER: number;
    BLOCK_START_INLINE_START: number;
    BLOCK_START_INLINE_CENTER: number;
    BLOCK_START_INLINE_END: number;
    INLINE_START_BLOCK_CENTER: number;
    INLINE_START_BLOCK_START: number;
    INLINE_START_BLOCK_END: number;
    INLINE_END_BLOCK_START: number;
    INLINE_END_BLOCK_CENTER: number;
    INLINE_END_BLOCK_END: number;
    BLOCK_END_INLINE_START: number;
    BLOCK_END_INLINE_CENTER: number;
    BLOCK_END_INLINE_END: number;
};
export declare const GoogleToMaplibreControlPosition: {};
export interface AddListenerResponse {
    instance: any;
    eventName: string;
    handler?: any;
    resultHandler?: any;
    resultsHandler?: any;
    listenerType?: string;
}
export declare const MigrationEvent: {
    click: string;
    dblclick: string;
    contextmenu: string;
    mousemove: string;
    mouseout: string;
    mouseover: string;
    tilesloaded: string;
    tilt_changed: string;
    zoom_changed: string;
    drag: string;
    dragend: string;
    dragstart: string;
    close: string;
    closeclick: string;
};
export declare const GoogleToMaplibreEvent: {};
export declare const GoogleMapMouseEvent: string[];
export declare const GoogleMapEvent: string[];
export declare const GoogleMarkerMouseEvent: string[];
export declare const GoogleMarkerMouseDOMEvent: string[];
export declare const GoogleInfoWindowEvent: string[];
export interface QueryAutocompletePrediction {
    description: string;
    place_id?: string;
}
